unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ppStrtch, ppCTMain, ppVar, ppPrnabl, ppClass, ppCtrls, ppBands,
  ppCache, daDataView, daQueryDataView, daDBBDE, ppModule, daDataModule,
  ppComm, ppRelatv, ppProd, ppReport, StdCtrls, ppEndUsr;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    daDataModule1: TdaDataModule;
    daBDEQueryDataView1: TdaBDEQueryDataView;
    Button1: TButton;
    ppDesigner1: TppDesigner;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    procedure CreateCrosstabInCode(aReport: TppReport);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ppCTDsgn;

{$R *.dfm}

procedure TForm1.Button3Click(Sender: TObject);
begin
  CreateCrosstabInCode(ppReport1);

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  ppReport1.Print;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  ppDesigner1.Show;

end;


procedure TForm1.CreateCrosstabInCode(aReport: TppReport);
var
  lCrossTab: TppCrossTab;
  liRowDimension: Integer;
  liValueDimension: Integer;
begin

  // create crosstab and place in the detail band
  lCrossTab := TppCrossTab.Create(Self);
  lCrossTab.Band := aReport.Detail;

  // assign the datapipeline
  lCrossTab.DataPipeline := daDataModule1.DataViews[0].DataPipelines[0];

  // initialize the available dimensions list based on the datapipeline
  lCrossTab.InitAvailableDimensions;

  // add a row dimension for CustNo
  liRowDimension := lCrossTab.IndexOfAvailableDimension('CustNo');
  lCrossTab.SelectRowDef(liRowDimension);

  // add a row dimension for OrderNo
  liRowDimension := lCrossTab.IndexOfAvailableDimension('OrderNo');
  lCrossTab.SelectRowDef(liRowDimension);

  // add a value dimension for AmountPaid
  liValueDimension := lCrossTab.IndexOfAvailableDimension('AmountPaid');
  lCrossTab.SelectValueDef(liValueDimension);

end;


end.
